#create file on filesystem in $ZOPE/Extensions called ftpme.py
import zLOG
import ftplib, sys, string
from StringIO import StringIO

host='localhost'
login='runyaga'
password='^%$^@5@#$S'
port=21

def ftp2http_reply(code):
    """
    Translate ftp return codes to http return codes (sorta).
    They will be returned as integers.
    """
    if type(code) == type(''):
        try:
            i = int(code)
            if i > 600:
                return 400
        except ValueError:
            return 400
    elif type(code) == type(0):
        if code > 600:
            return 400
        code = str(code)
    else:
	raise "Unknown code type %s" % str(code)
    if not code:
        return 400

    if code[:1] == '1': # continue
        return 100
    elif code[:1] == '2':
        return 204
    elif code[:1] == '3': # continue? dont know what else to send
        return 100
    elif code[:1] == '4': # couln't really find anything that fits so we say its timed out
        if code[1:3] == '21':
            return 405
        elif code[1:3] == '25':
            return 408
        elif code[1:3] == '26':
            return 408
        elif code[1:3] == '50':
            return 403
        elif code[1:3] == '51':
            return 500
        elif code[1:3] == '52':
            return 500
        else:
            return 408
    elif code[:1] == '5':
        if code[1:3] == '00':
            return 400 # bad request
        elif code[1:3] == '01':
            return 400 # bad request
        elif code[1:3] == '02': # not implemented
            return 501
        elif code[1:3] == '03':
            return 400
        elif code[1:3] == '04':
            return 501
        elif code[1:3] == '30':
            return 401
        elif code[1:3] == '32':
            return 401
        elif code[1:3] == '50':
            return 404
        elif code[1:3] == '51':
            return 400
        elif code[1:3] == '52':
            return 403
        elif code[1:3] == '53':
            return 403
        else:
            return 500

def ftp_dir_exists(ftpCon, path):
    zLOG.LOG('FTP', zLOG.INFO, 'ftp_dir_exists: %s?' % path)
    current = ftpCon.pwd()
    try:
        ftpCon.cwd(path)
        ftpCon.cwd(current)
        zLOG.LOG('FTP', zLOG.INFO, 'ftp_dir_exists: yes!')
        return 1
    except:
        zLOG.LOG('FTP', zLOG.INFO, 'ftp_dir_exists: exception %s!' % sys.exc_info()[1])
        # we assume it doesn't exist
        ftpCon.cwd(current)
        return 0

def ftp_mkpath(ftpCon, pathstr):
    """
    create an entire path string if it doesn't exist.
    remember not to include the filename
    """
    paths = string.split(pathstr, '/')

    path = "/"
    for dir in paths:
        path = "%s/%s" % (path, dir)
        if not ftp_dir_exists(ftpCon, path):
            try:
                resp = ftpCon.mkd(path)
                zLOG.LOG('FTP', zLOG.INFO, 'ftp_mkpath: respons from mkd: %s' % str(resp))
            except:
                zLOG.LOG('FTP', zLOG.INFO, 'ftp_mkpath: exception on mkd %s!' % sys.exc_info()[1])


def ftp(file=None, obj=None, text=None, host=host, login=login, password=password, port=port, remote_directory="", remote_name=""):
    if file is None and obj is None and text is None:
        return (400, "Both file, obj and text is None")
    zLOG.LOG('FTP', zLOG.INFO, '%s/%s / %s - %s %s' % (host,remote_directory, remote_name,login, password))
    _ftp = ftplib.FTP()
    _ftp.debugging = 1
    resp = (0,'')
    try:
        _ftp.connect(host, port)
        zLOG.LOG('FTP', zLOG.INFO, 'Connected')
    except ftplib.all_errors:
        zLOG.LOG('FTP', zLOG.INFO, 'Not Connected')
        return (ftp2http_reply(str(sys.exc_value)), sys.exc_value)

    try:
        _ftp.login(login, password)
        zLOG.LOG('FTP', zLOG.INFO, 'Logged in')
    except ftplib.all_errors:
        zLOG.LOG('FTP', zLOG.INFO, 'Not Logged in')
        _ftp.quit()
        return (ftp2http_reply(str(sys.exc_value)), sys.exc_value)

    # normalize remote_name and remote_path
    slashidx = string.rfind(remote_name, '/')
    if slashidx != -1:
        p = remote_name[:slashidx]
        remote_directory = string.join((remote_directory, p), '/')
        remote_name = remote_name[slashidx+1:]
        zLOG.LOG('FTP', zLOG.INFO, 'Fixing name and path: [%s] [%s]' % (remote_directory, remote_name))

    if remote_directory:
        if not ftp_dir_exists(_ftp, remote_directory):
            try:
                ftp_mkpath(_ftp, remote_directory)
            except:
                zLOG.LOG('FTP', zLOG.INFO, 'exception %s when trying to create path %s!' % (sys.exc_info()[1], remote_directory))
                _ftp.quit()
                return (ftp2http_reply(str(sys.exc_value)), sys.exc_value)
        try:
            _ftp.cwd(remote_directory)
            zLOG.LOG('FTP', zLOG.INFO, 'CWD to %s' % remote_directory)
        except:
            zLOG.LOG('FTP', zLOG.INFO, 'Could not CWD to %s' % remote_directory)
            _ftp.quit()
            return (ftp2http_reply(str(sys.exc_value)), sys.exc_value)

    if text:
        resp = ftp_text(_ftp, text, remote_name)
    elif file:
        if not remote_name:
            zLOG.LOG('FTP', zLOG.INFO, 'No remote name!')
            _ftp.quit()
            return (412, "When ftp'ing filesystem files supply a remote name.")
        binary = 1 # we go all binary
        resp = ftp_file(_ftp, file, binary, remote_name)
        zLOG.LOG('FTP', zLOG.INFO, 'Response on ftp_file %s' % str(resp))

    elif obj:
        if lower(obj.meta_type)=='file':
            binary=1
            if obj.content_type[:4]=='text': binary=0
            resp = ftp_obj(_ftp, obj, binary, remote_name)

        if lower(obj.meta_type)=='image':
            ftp_file(_ftp, obj, 1, remote_name)
    else:
        zLOG.LOG('FTP', zLOG.INFO, 'FALLTHRU!!!')

    _ftp.quit()
    _ftp = None
    zLOG.LOG('FTP', zLOG.INFO, 'Logged out')
    return (ftp2http_reply(str(resp)), resp)

def ftpdelete(ftpCon, fn):
    zLOG.LOG('FTP', zLOG.INFO, 'ftpdelete <%s>' % fn)
    # see first if the file is there at all
    try:
        ftpCon.size(fn)
        try:
            ftpCon.delete(fn)
            zLOG.LOG('FTP', zLOG.INFO, 'ftpdelete: %s deleted' % fn)
        except ftplib.error_perm:
            zLOG.LOG('FTP', zLOG.INFO, 'ftpdelete: exception permission')
            zLOG.LOG('FTP', zLOG.INFO, '%s' % sys.exc_info()[1])
            return 0
        except ftplib.error_reply:
            zLOG.LOG('FTP', zLOG.INFO, 'ftpdelete: exception reply')
            zLOG.LOG('FTP', zLOG.INFO, '%s' % sys.exc_info()[1])
            return 1
        except:
            zLOG.LOG('FTP', zLOG.INFO, 'ftpdelete: unknown exception')
            zLOG.LOG('FTP', zLOG.INFO, '%s' % sys.exc_info()[1])
            return 0

    except:
        # there is no such file
        zLOG.LOG('FTP', zLOG.INFO, 'ftpdelete: no such file (%s)' % sys.exc_info()[1])
        return 1

def formatresp(resp):
    # returns a tuple with an integer response code and an (maybe) informative string
    if type(resp) == type(('')):
        return resp
    elif type(resp) == type(''):
        try:
            i = int(resp[:3])
            if i < 600:
                return (i, resp[3:].strip())
            else:
                return (400, resp)
        except:
            return (400, resp)
    elif type(resp) == type(0):
        return (resp, "")
    else: # ?
        return resp

def ftp_file(ftpCon, file, binary, remote_name):
    name = remote_name
    ftpdelete(ftpCon, name)
    #    zLOG.LOG('FTP', zLOG.INFO, 'ftp_file: couldnt delete remote file %s - trying to upload.' % name)
    try:
        if binary:
	    zLOG.LOG('FTP', zLOG.INFO, 'ftp_file: trying to upload %s' % name)
            resp = ftpCon.storbinary("STOR " + name, file, 1024)
        else:
            resp = ftp_text(ftpCon, file, name)

        resp = formatresp(resp)
        zLOG.LOG('FTP', zLOG.INFO, 'Response in ftp_file %s' % str(resp))
        return resp
    except ftplib.all_errors:
	zLOG.LOG('FTP', zLOG.INFO, 'Exception in ftp_file %s' % str(sys.exc_info()[1]))
        return formatresp(sys.exc_info()[1])

def ftp_obj(ftpCon, fileObj, binary, remote_name = ""):
    if ftpdelete(ftpCon, remote_name):
        if not remote_name:
            name = fileObj.getId()
        else:
            name = remote_name
        try:
            if binary:
                resp =  ftpCon.storbinary("STOR " + name, StringIO(fileObj.data), 1024)
            else:
                resp =  ftp_text(ftpCon, fileObj.data, name)
            resp = formatresp(resp)
            zLOG.LOG('FTP', zLOG.INFO, 'Response in ftp_obj %s' % str(resp))
            return resp
        except ftplib.all_errors:
            return formatresp(sys.exc_info()[1])
    else:
        zLOG.LOG('FTP', zLOG.INFO, 'Couldn''t delete remote file: %s' % remote_name)
        return (450, "Permission denied, cant delete")

def ftp_text(ftpCon, text, remote_name = ""):
    if not remote_name:
        return (450, "No remote name supplied")
    else:
        try:
            return formatresp(ftpCon.storlines("STOR " + remote_name, StringIO(text)))
        except ftplib.all_errors:
            return formatresp((sys.exc_info()[1]))

