##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
import zLOG
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from AccessControl import ClassSecurityInfo
from Acquisition import aq_parent, aq_inner, aq_base
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl


factory_type_information = ({
      'id': 'Show',
      'meta_type': 'Media Manager Show',
      'description': 'Use show to make new Media Show',
      'product': 'MyMediaManager',
      'icon': 'show_icon.gif',
      'factory': 'addMediaShow',
      'filter_content_types': 0,
      'immediate_view': 'mediashow_edit_form',
      'actions':
            ({'name': 'View',
                'action': 'mediashow_view',
            'permissions': ('View',),
            'category': 'object'},
            {'name': 'Edit',
                'action': 'mediashow_edit_form',
            'permissions': ('Modify portal content',),
            'category': 'object'},
            {'name': 'Add Clip',
                'action': 'mediashow_add_clip_form',
            'permissions': ('Modify portal content',),
            'category': 'object'})
       },)


class MediaShow( PortalContent, PortalFolder
          , DefaultDublinCoreImpl
          ):
    """
        A Link
    """

    meta_type='Media Manager Show'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.clips = []
        self.description=description

    def listClips( self ):
        """
        List All offsets available
       """
        clips = []
        ob = self
        while ob is not None and not getattr(ob, '_isPortalRoot', 0):
            ob = aq_parent(aq_inner(ob))

        for clip in self.clips:
            try:
                if ob.restrictedTraverse(clip).meta_type == "Media Manager Clip":
                    clips.append(clip)
                zLOG.LOG('media show', zLOG.INFO, 'Appending slip path: %s' % clip)
            except:
                zLOG.LOG('media show', zLOG.INFO, 'Skiping clip path: %s' % clip)
                pass
	   
        return tuple(clips)

    def listClipObjects( self ):
        """
        List All offsets available
        """
        clips = []
        ob = self
        while ob is not None and not getattr(ob, '_isPortalRoot', 0):
            ob = aq_parent(aq_inner(ob))

        for clip in self.listClips():
            try:
                clips.append(ob.restrictedTraverse(clip))
                zLOG.LOG('Media Show', zLOG.INFO, 'Append clip: %s' % clip)
            except:
                zLOG.LOG('Media Show', zLOG.INFO, 'Skipping clip: %s' % clip)
                pass
        
        return tuple(clips)

    security.declareProtected(View, 'lookup')
    def lookup(self, userset=None):
        """
        returns the URL nedded
        """
        zLOG.LOG("MediaShow", -100, "Lookup called")
        #ob = self.unrestrictedTraverse('../..', default=None)
        #if ob is not None:
        relative = "%s" % (self.id)
        ob = self.unrestrictedTraverse('..', default=None)
        if ob is None:
            raise "DEBUG", "MasterFile not contained in Medianet"
        while not (ob.meta_type == "Media Manager Medianet"):
            obn = ob.unrestrictedTraverse('..', default=None)
        if obn is None:
            raise "DEBUG", "MasterFile not contained in Medianet"
        if not (obn.meta_type == "Media Manager Medianet"):
            relative = "%s/%s" % (ob.id,relative)
            ob = obn 
        #zLOG.LOG ("MasterFile", -100, "Found %s %s" % (ob.absolute_url(), ob.meta_type))
        return  ob.lookupMasterFile(object=self, name=relative, userset=userset)

    security.declareProtected(View, 'getClip')
    def getClip( self, pIndex ):
        index = int(pIndex)
        zLOG.LOG("MediaShow", zLOG.TRACE, "Fetching logic %s return: %s" % (index, self.clips[index]))
        return self.clips[index]

    security.declareProtected(ManageProperties, 'moveUp')
    def moveUp( self, pIndex ):
        """
        """
        index = int(pIndex)
        #raise "DEBUG", "Assign %s to %s" % (id, offset)
        zLOG.LOG("MediaShow", -100, "moveUp %s" % (index))
        if index>0 and index<len(self.clips):
            old = self.clips[index-1]
            self.clips[index-1] = self.clips[index]
            self.clips[index] = old
            self._p_changed = 1
            zLOG.LOG("MediaShow", 0, "switched clips. Id: %s was swithed with id: %s" % (index, index-1))
        else:
            zLOG.LOG("MediaShow", 0, "Something went wrong. Index is %s and length of clips is: %s" % (index, len(self.clips)))

    security.declareProtected(ManageProperties, 'moveDown')
    def moveDown( self, pIndex ):
        """
        """
        index=int(pIndex)
        zLOG.LOG("MediaShow", zLOG.TRACE, "moveDown %s" % (index))
        if index<len(self.clips)-1 and index>=0:
            old = self.clips[index+1]
            self.clips[index+1] = self.clips[index]
            self.clips[index] = old
            self._p_changed = 1

    security.declareProtected(ManageProperties, 'delete')
    def delete( self, pIndex ):
        """
        """
        index=int(pIndex)
        zLOG.LOG("MediaShow", zLOG.INFO, "delete %s %s" % (index, len(self.clips)))
        if index>=0 and index<len(self.clips):
            del self.clips[index]
            self._p_changed = 1
            zLOG.LOG("MediaShow", zLOG.INFO, "Deleted %s" %(index))

    security.declareProtected(ManageProperties, 'append')
    def append( self, clip ):
        """
        """
        zLOG.LOG("MediaShow", zLOG.INFO, "append %s" % (clip))
        self.clips.append(clip)
        self._p_changed = 1

    security.declarePublic('clipCount')
    def clipCount(self):
        return int(len(self.clips))

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    security.declarePublic('synContentValues')
    def synContentValues(self):
        """
        returns the syndicatable objects.
        """
        #return map(self.aq_parent.restrictedTraverse, self.listClipObjects())
        return self.listClipObjects()

def addMediaShow(self, id, title='', REQUEST=None):
	ob=MediaShow(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(MediaShow)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(MediaShow,
                      constructors=(addMediaShow,),
		      action='mediashow_edit_form',
		      icon='show_icon.gif')
