## Script (Python) "subevent_handler"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=return_skin, manipulator_id=None,  convert=None, delete=None, change_status=None, create_or_save=None
##title=
REQUEST = context.REQUEST
user = context.portal_membership.getAuthenticatedMember()
isReview = user.has_role('Reviewer')
isMan = user.has_role('Manager')

if not REQUEST.has_key('return_skin'):
    return REQUEST.RESPONSE.redirect(context.absolute_url() + '?portal_status_message=return+skin+missing')


if create_or_save:
    if create_or_save == 'create':
        #print 'creating new subevent\n'
        sub_e_id = context.portal_mediamanager.getUniqueID()
        if context.meta_type == 'Media Manager Live Event':
            folder_obj = context
            event_start = DateTime(context.getStartTimeString()).Time()
        elif context.meta_type == 'Media Sub Event':
            folder_obj = context.restrictedTraverse('..')
            event_start = folder_obj.getStartTimeString()
        folder_obj.invokeFactory(id=sub_e_id, type_name='Sub Event')
        obj = context.restrictedTraverse(sub_e_id)
        start = DateTime(REQUEST['start_date']).strftime('%Y/%m/%d')
        stop = DateTime(REQUEST['stop_date']).strftime('%Y/%m/%d')
        obj.edit(title=REQUEST['title'], description=REQUEST['description'], effectiveDate=start,
                expirationDate=stop, start_time=REQUEST['start_time'], stop_time=REQUEST['stop_time'], body=REQUEST['body'], identifier=REQUEST['identifier'])
        status_msg = 'Sub+Event+created'
    elif create_or_save == 'create_with_mark':
        folder_obj = context.portal_mediamanager.getEventFor(context)
        sub_e_id = context.portal_mediamanager.getUniqueID()
        event_start = folder_obj.getStartTimeString()
        subevents = folder_obj.objectValues('Media Sub Event')
        #print "subevents: %s" % str(subevents)
        last = None
        # get the last subevent
        if len(subevents) > 0: # if we can get the last sub event we use its end time as start time
            last = subevents[len(subevents)-1]
        folder_obj.invokeFactory(id=sub_e_id, type_name='Sub Event')
        obj = context.restrictedTraverse(sub_e_id)
        if 0: #last:
            stop = DateTime(REQUEST['stop_date']).strftime('%Y/%m/%d')
            obj.edit(title=REQUEST['title'], description=REQUEST['description'], expirationDate=stop, stop_time=REQUEST['stop_time'], body=REQUEST['body'], identifier=REQUEST['identifier'])
            obj.setStartDate(last.end())
        else:
            start = DateTime(REQUEST['start_date']).strftime('%Y/%m/%d')
            stop = DateTime(REQUEST['stop_date']).strftime('%Y/%m/%d')
            obj.edit(title=REQUEST['title'], description=REQUEST['description'], effectiveDate=start, expirationDate=stop, start_time=REQUEST['start_time'], stop_time=REQUEST['stop_time'], body=REQUEST['body'], identifier=REQUEST['identifier'])
        status_msg = 'Sub+Event+created+and+time+set&new_start_time=' + REQUEST['stop_time']
        #return printed
    elif create_or_save == 'save':
        obj = context
        start = DateTime(REQUEST['start_date']).strftime('%Y/%m/%d')
        stop = DateTime(REQUEST['stop_date']).strftime('%Y/%m/%d')
        obj.edit(title=REQUEST['title'], description=REQUEST['description'], effectiveDate=start,
                expirationDate=stop, start_time=REQUEST['start_time'], stop_time=REQUEST['stop_time'], body=REQUEST['body'], identifier=REQUEST['identifier'])
        status_msg = 'Sub+Event+saved'
elif manipulator_id:
    if delete:
        context.manage_delObjects(manipulator_id, REQUEST)
        status_msg = 'Sub+Event(s)+deleted.'
        return_url = context.absolute_url() + '/' + REQUEST['return_skin'] + '?portal_status_message=' + status_msg
        #return REQUEST.RESPONSE.redirect(return_url)
    elif change_status:
        if REQUEST.has_key('state_change'):
            for id in manipulator_id:
                obj = context.restrictedTraverse(id)
                # the commented out section first checks if we are allowed to change state.
                # in the new workflow there's no 'id' so we just wrap it into a
                # 'try' statement instead
                #status = context.portal_workflow.getInfoFor(obj, 'review_state', '')
                #for w in context.portal_actions.listFilteredActionsFor(obj)['workflow']:
                #    if REQUEST['state_change'] == w['id']:
                #      context.portal_workflow.doActionFor(obj, REQUEST['state_change'])
                try:
                    context.portal_workflow.doActionFor(obj, REQUEST['state_change'])
                except:
                    pass
            status_msg = 'Status+changed+to+%s.' % (REQUEST['state_change'])
        else:
            status_msg = 'No+new+status+selected'
    elif convert:
        if not REQUEST.has_key('live_event'):
            REQUEST.RESPONSE.redirect(context.absolute_url() + '?portal_status_message=No+event+selected!')
        folder_obj = context.restrictedTraverse(REQUEST['live_event'])
        event_start = DateTime(context.getStartTimeString()).Time()

        # are we just looking for one master file here?
        for m in context.objectValues('Media Manager Master File'):
            master_encstart = m.encoder_start
            if not master_encstart:
                master_encstart = event_start
            master_obj = m
            master_url = m.absolute_url(relative = 1)
            master_title = m.title
        trans = {'':'ae','':'oe','':'aa','':'Ae','':'Oe','':'Aa',' ':'_','.':''}
        master_title_trans = master_title
        for l in trans.keys(): # I would love to be better at regular expression (thomas)
            master_title_trans = string.replace(master_title_trans, l, trans[l])
        item_count = 0
        for id in manipulator_id:
            item_count = item_count + 1
            obj = context.restrictedTraverse(id)
            clip_id = '%s_%d' % (context.portal_mediamanager.getUniqueID(obj.Creator()), item_count)
            start_strings = obj.getStartStrings()
            start_date = '%s/%s/%s' % (start_strings['year'], start_strings['month'], start_strings['day'])
            #print 'Calling invokeFactory width id: %s\n' % clip_id
            folder_obj.invokeFactory(id=clip_id, type_name='Clip')
            c_obj = context.restrictedTraverse(clip_id)
            c_obj.setTimeCodes(
                             '%s:00' % str(context.getOffset(master_encstart, obj.getStartTimeString())),
                             '%s:00' % str(context.getOffset(master_encstart, obj.getStopTimeString()))
                              )
            #print 'Calling editMetadata width title: %s, effective_date: %s\n' % (obj.title, start_date)
            c_obj.editMetadata(title=obj.title, description=obj.description, subject='', contributors='',
                              effective_date=start_date, expiration_date='9999/01/01', format='', language='', rights=''
                               )
            clip_title_trans = obj.title
            for l in trans.keys(): # I would love to be better at regular expression (thomas)
                clip_title_trans = string.replace(clip_title_trans, l, trans[l])
            basename = '%s_%s%s' % (master_title_trans, obj.identifier, clip_title_trans)
            #print 'basename: %s\n' % basename
            c_obj.editClip(body=obj.body, identifier=obj.identifier, smilname='%s.smil' % basename, rpmname='%s.rpm' % basename)
            c_obj.setMasterFilePath('/%s' % master_obj.absolute_url(relative=1))
        #return printed
        status_msg = 'Clip(s)+created'

else:
    status_msg = 'Please+select+one+or+more+sub+events+before+trying+to+apply+an+action.'
return REQUEST.RESPONSE.redirect(context.absolute_url() + '/' + REQUEST['return_skin'] + '?portal_status_message=' + status_msg + '&amp;refresh_medialist=true')
